import copy
import numpy as np
import random
import AEACO
def xuanzhe(bezhongqun,zhongqun,Z_JL,xinxi):
    # print(bezhongqun)
    # print(zhongqun)
    alpha=3
    beta=10
    etale=1/Z_JL
    protrans1= np.zeros(len(bezhongqun))
    for i in range(len(bezhongqun)):
        for j in range(len(zhongqun)):
            protrans1[i]=protrans1[i]+np.power(xinxi[bezhongqun[i]][zhongqun[j]],alpha)\
                         *np.power(etale[bezhongqun[i]][zhongqun[j]],beta)
    cumsumprobtrans = (protrans1 / np.sum(protrans1)).cumsum()
    cumsumprobtrans -= np.random.rand()
    # print(cumsumprobtrans)
    k = bezhongqun[list(cumsumprobtrans > 0).index(True)]
    return k
def zhixing(data,t,Z_C,Z_JL,Z_Z,sumx):
    for i in range(len(Z_Z)):
        X=Z_C[t[i]]
        if len(X)<2:
            sumx[t[i]]=0
            Z_C[t[i]]=X.copy()
            continue
        X.remove(Z_Z[i][0])
        X.remove(Z_Z[i][1])
        X[0:0]=[Z_Z[i][0]]
        X[len(X):len(X)]=[Z_Z[i][1]]
        one=[]
        one1=[]
        for j in X:
            one.append(data[int(j)])
        hunhei1,hunhei2=AEACO.ant(city_count=len(one), city_condition=one)
        sumx[t[i]]=hunhei2
        for k in hunhei1:
            one1.append(X[k])
        Z_C[t[i]]=one1.copy()
    #         c_s[z_1[ck]]=one1.copy()
    sumX1=np.sum(sumx)
    for it in range(len(Z_C)-1):
        sumX1=sumX1+Z_JL[Z_C[it][-1]][Z_C[it+1][0]]
    sumX1 = sumX1+Z_JL[Z_C[-1][-1]][Z_C[0][0]]
    # oneex = sum(Z_C, [])
    # o=0
    # for i in range(len(oneex)-1):
    #     o=o+Z_JL[oneex[i]][oneex[i+1]]
    # o=o+Z_JL[oneex[-1]][oneex[0]]
    # oneex.sort()
    return sumX1,sumx,Z_C
def Yant(data,Z_C,YS,Z_JL,xinxi):
    #Z_J是两个相邻簇的最近结果
    Z_Z=np.zeros((len(YS),2),dtype=np.int)
    Z_C1=[]
    sum_z=np.zeros(len(YS))
    for i in range(len(Z_C)):
        Z_C1.append(copy.copy(Z_C[YS[i]].tolist()))
    for i in range(len(YS)-1):
        if len(Z_C1[i])<2:
            Z_Z[i, 0]=Z_C1[i][0]
            Z_Z[i, 1] = Z_C1[i][0]
            continue
        k1=xuanzhe(bezhongqun=Z_C1[i],zhongqun=Z_C1[i-1],Z_JL=Z_JL,xinxi=xinxi)
        Z_Z[i, 0]=k1
        Z_C1[i].remove(k1)
        Z_Z[i,1] = xuanzhe(bezhongqun=Z_C1[i], zhongqun=Z_C1[i+1], Z_JL=Z_JL, xinxi=xinxi)
        Z_C1[i].append(k1)
    if len(Z_C1[-1]) < 2:
        Z_Z[-1, 0] = Z_C1[-1][0]
        Z_Z[-1, 1] = Z_C1[-1][0]
    else:
        k2 = xuanzhe(bezhongqun=Z_C1[-1], zhongqun=Z_C1[-2], xinxi=xinxi, Z_JL=Z_JL)
        Z_Z[len(YS) - 1, 0] = k2
        Z_C1[-1].remove(k2)
        Z_Z[len(YS) - 1, 1] = xuanzhe(bezhongqun=Z_C1[-1], zhongqun=Z_C1[0], xinxi=xinxi, Z_JL=Z_JL)
        Z_C1[-1].append(k2)
    return zhixing(data=data,Z_C=Z_C1,t=[i for i in range(len(YS))],Z_JL=Z_JL,Z_Z=Z_Z,sumx=sum_z)
def j_dis(JL,data,YS,c_j,c_s,xinxi1):
    #dj1每个簇的结果值，#cs11每个簇结果顺序
    #cj是结果值，cs是序列
    c_j1=c_j.copy()
    c_s11=c_s.copy()
    Z_Z=np.zeros((2,2), dtype=np.int)
    a = random.randint(0, len(YS) - 1)
    b = random.randint(0, len(YS) - 1)
    n = 0
    while n < 1:
        if a == b:
            b = random.randint(0, len(YS) - 1)
        else:
            n = 3
    if a>b:
        a,b=b,a
    #簇顺序交换
    YS[a: b + 1] = YS[a: b + 1][::-1]
    c_j1[a: b+1]=c_j1[a: b+1][::-1]
    for j_h in range(a,b+1):
        c_s11[j_h][0:len(c_s11[j_h])]=c_s11[j_h][0: len(c_s11[j_h])][::-1]
    c_s11[a: b + 1] = c_s11[a: b + 1][::-1]
    if len(c_s11[a]) < 2:
        Z_Z[0, 0] =  c_s11[a][0]
        Z_Z[0, 1] =  c_s11[a][0]
    else:
        k1 = xuanzhe(bezhongqun=c_s11[a], zhongqun=c_s11[a - 1], Z_JL=JL, xinxi=xinxi1)
        Z_Z[0, 0]=k1
        c_s11[a].remove(k1)
        Z_Z[0, 1] = xuanzhe(bezhongqun=c_s11[a], zhongqun=c_s11[a + 1], Z_JL=JL, xinxi=xinxi1)
        c_s11[a].append(k1)
    if len(c_s11[b]) < 2:
        Z_Z[1, 0] = c_s11[b][0]
        Z_Z[1, 1] = c_s11[b][0]
    else:
        if b == len(YS) - 1:
            k2 = xuanzhe(bezhongqun=c_s11[b], zhongqun=c_s11[b - 1], Z_JL=JL, xinxi=xinxi1)
            Z_Z[1, 0]=k2
            c_s11[b].remove(k2)
            Z_Z[1, 1] = xuanzhe(bezhongqun=c_s11[b], zhongqun=c_s11[0], Z_JL=JL, xinxi=xinxi1)
            c_s11[b].append(k2)
        else:
            k2 = xuanzhe(bezhongqun=c_s11[b], zhongqun=c_s11[b - 1], Z_JL=JL, xinxi=xinxi1)
            Z_Z[1, 0] = k2
            c_s11[b].remove(k2)
            Z_Z[1, 1] = xuanzhe(bezhongqun=c_s11[b], zhongqun=c_s11[b + 1], Z_JL=JL, xinxi=xinxi1)
            c_s11[b].append(k2)
    sumX1,cxj,cxs=zhixing(data=data,Z_C=c_s11,t=[a,b],Z_JL=JL,Z_Z=Z_Z,sumx=c_j1)
    return YS,sumX1,cxj,cxs
def J_dist(JL,data,ys,c_j,c_s,xinxi1):#YS1是交换前，YS是交换后
    c_j1 = c_j.copy()
    c_s11 = c_s.copy()
    Z_Z = np.zeros((2, 2), dtype=np.int)
    if len(c_s11[ys[0]]) < 2:
        Z_Z[0, 0] = c_s11[ys[0]][0]
        Z_Z[0, 1] = c_s11[ys[0]][0]
    else:
        k1 = xuanzhe(bezhongqun=c_s11[ys[0]], zhongqun=c_s11[ys[0] - 1], Z_JL=JL, xinxi=xinxi1)
        Z_Z[0, 0] = k1
        c_s11[ys[0]].remove(k1)
        Z_Z[0, 1] = xuanzhe(bezhongqun=c_s11[ys[0]], zhongqun=c_s11[ys[0] + 1], Z_JL=JL, xinxi=xinxi1)
        c_s11[ys[0]].append(k1)
    if len(c_s11[ys[1]]) < 2:
        Z_Z[1, 0] = c_s11[ys[1]][0]
        Z_Z[1, 1] = c_s11[ys[1]][0]
    else:
        if ys[1] == len(c_j1) - 1:
            k2 = xuanzhe(bezhongqun=c_s11[ys[1]], zhongqun=c_s11[ys[1] - 1], Z_JL=JL, xinxi=xinxi1)
            Z_Z[1, 0] = k2
            c_s11[ys[1]].remove(k2)
            Z_Z[1, 1] = xuanzhe(bezhongqun=c_s11[ys[1]], zhongqun=c_s11[0], Z_JL=JL, xinxi=xinxi1)
            c_s11[ys[1]].append(k2)
        else:
            k2 = xuanzhe(bezhongqun=c_s11[ys[1]], zhongqun=c_s11[ys[1] - 1], Z_JL=JL, xinxi=xinxi1)
            Z_Z[1, 0] = k2
            c_s11[ys[1]].remove(k2)
            Z_Z[1, 1] = xuanzhe(bezhongqun=c_s11[ys[1]], zhongqun=c_s11[ys[1] + 1], Z_JL=JL, xinxi=xinxi1)
            c_s11[ys[1]].append(k2)
    return zhixing(data=data, Z_C=c_s11, t=ys, Z_JL=JL, Z_Z=Z_Z, sumx=c_j1)
