import copy
from sklearn.metrics.pairwise import pairwise_distances
import numpy as np
def juli(A):
    D = pairwise_distances(A, metric='euclidean')
    return D
def kMedoids(D, k,time=40, tmax=15000):
    rs, cs = np.shape(D)
    if k>rs:
        raise Exception('too many medoids')
    else:
        index_shuf = list(range(rs))
        np.random.shuffle(index_shuf)
        initial_num=np.sort(index_shuf[:k])
        finally_num=np.copy(initial_num)
        C={}
        for i in range(tmax):
            J = np.argmin(D[:, initial_num], axis=1)
            for j in range(k):
                C[j]=np.where(J == j)[0]
            n1=-1
            while n1<100:
                tx=np.zeros(k)
                for j in range(k):
                    tx[j]=len(C[j])
                txz=np.where(tx>time)[0]
                if len(txz)==0:
                    n1=200
                else:
                    for j in txz:
                        initial_num1 = copy.copy(initial_num).tolist()
                        num1=[list(range(len(C[j])))]
                        DX = D[C[j], initial_num[j]]
                        sorted_id = sorted(range(len(DX)), key=lambda k1: DX[k1], reverse=False)[0:time]
                        wh_shuf1=C[j][np.setdiff1d(num1,sorted_id)]
                        C[j] = C[j][sorted_id]
                        initial_num1.remove(initial_num1[j])
                        wh_J = np.argmin(np.delete(D[:, initial_num1], np.setdiff1d(index_shuf, wh_shuf1), axis=0), axis=1)
                        for wh_x in range(len(initial_num1)):
                            C[np.where(initial_num==initial_num1[wh_x])[0][0]]=np.hstack((C[np.where(initial_num==initial_num1[wh_x])[0][0]],wh_shuf1[np.where(wh_J == wh_x)[0]]))
                n1=n1+1
            for j in range(k):
                t1=D[np.ix_(C[j],C[j])]
                t2=np.mean(t1,axis=1)
                J=np.argmin(t2)
                finally_num[j]=C[j][J]
            np.sort(finally_num)
            if np.array_equal(finally_num,initial_num):
                break
            initial_num=np.copy(finally_num)
        return initial_num,C
# Z_center, Z_array = Kmed.kMedoids(JL[0:len(JL)], canshu1[0])  # Z_P是镞类的中心点，Z_C是一个个簇类，是字典型
#         arr_1 = np.zeros(len(Z_array))
#         NX=0
#         while NX==0:
#             for ARR in range(len(Z_array)):
#                 arr_1[ARR] = len(Z_array[ARR])
#             txz = np.where(arr_1 > 15)[0]
#             if len(txz) == 0:
#                 NX= 200
#             else:
#                 Z_center, Z_array = Kmed.kMedoids(JL[0:len(JL)], canshu1[0])  # Z_P是镞类的中心点，

